//
// authour: Gregg Edghill
// Copyright (C) 2004, Gregg Edghill (gs_edghill@hotmail.com)
//
// button.h
//

#ifndef KDECORATION_WHID_Button
#define KDECORATION_WHID_Button

#include <qbutton.h>
#include <qimage.h>

#include "factory.h"

namespace KDecorationWhid
{
	class Client;
	class Button : public QButton
	{
		Q_OBJECT

		public:
			Button(Client *parent=0, const char *name=0, const QString &tip=0, Qt::AlignmentFlags align=AlignHCenter, ButtonType type=helpButton);
		   ~Button();

			Client* GetClient();
			ButtonState mouseButtonState();
			void reset();
			void setMaximized(bool maximized);
			QSize sizeHint() const;

		private:
			void drawButton(QPainter *painter);
			void resetIcon();
			void enterEvent(QEvent *event);
			void leaveEvent(QEvent *event);
			void mousePressEvent(QMouseEvent *mouse);
			void mouseReleaseEvent(QMouseEvent *mouse);

			ButtonType type;
			ButtonState state;
			Qt::AlignmentFlags align;

			QImage icon;

			bool isMouseOver;
			bool isMaximized;

			Client *client;
	};

	/// <copyright>
	/// Copyright (C) 2003 by Sandro Giessl
	/// <copyright>
	QImage recolorImage(QImage *that, QColor newcolor);
}
#endif

