//
// authour: Gregg Edghill
// Copyright (C) 2004, Gregg Edghill (gs_edghill@hotmail.com)
//
// client.h
//

#ifndef region_Whid_client_h
#define region_Whid_client_h

#include "factory.h"

class QSpacerItem;
class QVBoxLayout;
class QHBoxLayout;

class QBoxLayout;

namespace KDecorationWhid
{
	class Button;

	class Client : public KDecoration
	{
		Q_OBJECT

		public:
			Client(KDecorationBridge *bridge, KDecorationFactory *factory);

			virtual void init();
			virtual void borders(int& left, int& right, int& top, int& bottom) const;
			virtual bool eventFilter(QObject *obj, QEvent *event);
			virtual QSize minimumSize() const;
			virtual void resize(const QSize& that);
			virtual void show();

			~Client();

		protected:
			virtual void mouseDoubleClickEvent(QMouseEvent *event);
			virtual void paintEvent(QPaintEvent *event);
			virtual void resizeEvent();
    		virtual void showEvent(QShowEvent *event);
    		virtual void windowWrapperShowEvent(QShowEvent *event);

			virtual void activeChange();
			virtual void captionChange();
			virtual void desktopChange();
			virtual void doShape();
			virtual void iconChange();
			virtual void maximizeChange();
			virtual Position mousePosition(const QPoint &mouse) const;
			virtual void reset(unsigned long changed);
    		virtual void shadeChange();

		private slots:
			bool isToolWindow();
			void maximizeWindow();
			void menuButtonPressed ();
			void menuButtonReleased();

		private:
			void addButtons(QBoxLayout *parent, const QString &buttons);
			void initializeComponents();
			void updateCaption();

		private: QVBoxLayout *components;

			QSpacerItem *spacerItemTop;
			QSpacerItem *spacerItemTitle;
			QSpacerItem *spacerItemLeftOfTitle, *spacerItemRightOfTitle;
			QSpacerItem *spacerItemLeft, *spacerItemRight;
			QSpacerItem *spacerItemBottom;

			Button  *buttonGroup [numberOfButtons];
			QHBoxLayout *buttonLayoutLeft, *buttonLayoutRight;

		private:
			bool isWindowClosing;
			bool titleCaptionChanged;

			QFont titleFont;
			int   titleHeight;
	};
}
#endif
