//
// authour: Gregg Edghill
// Copyright (C) 2004, Gregg Edghill (gs_edghill@hotmail.com)
//
// factory.cpp
//

#include <kconfig.h>
#include <qapplication.h>

#include "factory.h"
#include "client.h"

namespace KDecorationWhid
{
	bool Factory::initialized     = false;
	bool Factory::layout_reversed = false;

	Qt::AlignmentFlags Factory::titlefont_alignment = Qt::AlignLeft;;

	int Factory::titleheight      = 19;
	int Factory::titleheight_tool = 12;

	QFont Factory::titlefont      = QFont();
	QFont Factory::titlefont_tool = QFont();

	int Factory::bordersize       = 4;

	//
	//
	//
	Factory::Factory()
	{
		reset (1);
	}

	//
	//
	//
	Factory::~Factory()
	{
		initialized = false;
	}

	//
	//
	//
	bool Factory::reset(unsigned long changed)
	{
		titlefont       = KDecoration::options()->font(true, false);
		titlefont_tool  = titlefont;

		titlefont_tool.setPointSize(titlefont.pointSize() - 3);
		titlefont_tool.setWeight(QFont::Normal);

		layout_reversed = QApplication::reverseLayout();

		ReadConfig();

		initialized = true;

		resetDecorations(changed);

		return true;
	}

	//
	// create decoration
	//
	KDecoration* Factory::createDecoration(KDecorationBridge* bridge)
	{
		return new Client(bridge, this);
	}

	//
	// read configuration settings TODO
	//
	void Factory::ReadConfig()
	{
    	KConfig config("kwinwhidrc");
    	config.setGroup("General");

 	   // grab settings
		QString value = config.readEntry("TitleAlignment", "AlignHCenter");

		if (value == "AlignLeft") titlefont_alignment = Qt::AlignLeft;
		else if (value == "AlignHCenter") titlefont_alignment = Qt::AlignHCenter;
		else if (value == "AlignRight") titlefont_alignment = Qt::AlignRight;
	}
}

//
//
//
static KDecorationWhid::Factory *factory = 0;

extern "C"
{
	KDecorationFactory* create_factory()
	{
		factory = new KDecorationWhid::Factory();

		return (factory);
	}
}

#include "factory.moc"
