//
// authour: Gregg Edghill
// Copyright (C) 2004, Gregg Edghill (gs_edghill@hotmail.com)
//
// factory.h
//

#ifndef region_Whid_factory_h
#define region_Whid_factory_h

#include <kdecorationfactory.h>
#include <qfont.h>

namespace KDecorationWhid
{
	enum ButtonType {helpButton=0, closeButton, maximizeButton, minimizeButton, menuButton, numberOfButtons};

	class Factory : public QObject,
						public KDecorationFactory
	{
		Q_OBJECT

		public:
			Factory();

			virtual KDecoration* createDecoration(KDecorationBridge *bridge);
			virtual bool reset(unsigned long changed);

			static int BorderSize()
			{
				return bordersize;
			}

			static bool Initialized()
			{
				return initialized;
			}

			static bool IsLayoutReversed()
			{
				return layout_reversed;
			}

			static Qt::AlignmentFlags TitleFontAlignment()
			{
				return titlefont_alignment;
			}

			static int TitleHeight()
			{
				return titleheight;
			}

			static int TitleHeightTool()
			{
				return titleheight_tool;
			}

			static QFont TitleFont()
			{
				return titlefont;
			}

			static QFont TitleFontTool()
			{
				return titlefont_tool;
			}

			~Factory();

		private: void ReadConfig();

		private:
			static int bordersize;

			static bool initialized;
			static bool layout_reversed;

			static Qt::AlignmentFlags titlefont_alignment;

			static int titleheight;
			static int titleheight_tool;

			static QFont titlefont;
			static QFont titlefont_tool;
	};
}
#endif
